VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmView 
   Caption         =   "Form1"
   ClientHeight    =   8025
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   13320
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   ScaleHeight     =   535
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   888
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   7200
      Left            =   1920
      ScaleHeight     =   476
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   636
      TabIndex        =   11
      Top             =   120
      Width           =   9600
   End
   Begin VB.CommandButton cmdFill 
      Caption         =   "Fill Bottom Layer"
      Height          =   495
      Left            =   1320
      TabIndex        =   10
      Top             =   7320
      Width           =   2055
   End
   Begin VB.ComboBox cmbEdit 
      Height          =   315
      ItemData        =   "frmView.frx":0000
      Left            =   11760
      List            =   "frmView.frx":0002
      TabIndex        =   9
      Text            =   "Current Edit Level"
      Top             =   1440
      Width           =   1575
   End
   Begin VB.CommandButton cmdDown 
      Caption         =   "Down"
      Height          =   495
      Left            =   12120
      TabIndex        =   8
      Top             =   6720
      Width           =   735
   End
   Begin VB.CommandButton cmdRight 
      Caption         =   "Right"
      Height          =   495
      Left            =   12600
      TabIndex        =   7
      Top             =   6240
      Width           =   615
   End
   Begin VB.CommandButton cmdLeft 
      Caption         =   "Left"
      Height          =   495
      Left            =   11760
      TabIndex        =   6
      Top             =   6240
      Width           =   615
   End
   Begin VB.CommandButton cmdUp 
      Caption         =   "Up"
      Height          =   495
      Left            =   12120
      TabIndex        =   5
      Top             =   5760
      Width           =   735
   End
   Begin VB.TextBox txtEnterY 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1033
         SubFormatType   =   1
      EndProperty
      Height          =   375
      Left            =   10680
      TabIndex        =   3
      Text            =   "10"
      Top             =   7440
      Width           =   375
   End
   Begin VB.TextBox txtEnterX 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1033
         SubFormatType   =   1
      EndProperty
      Height          =   375
      Left            =   10200
      TabIndex        =   2
      Text            =   "10"
      Top             =   7440
      Width           =   375
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   7095
      Left            =   1560
      TabIndex        =   1
      Top             =   120
      Width           =   255
   End
   Begin VB.PictureBox picSurface 
      Height          =   7080
      Left            =   120
      ScaleHeight     =   468
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   92
      TabIndex        =   0
      Top             =   120
      Width           =   1440
   End
   Begin MSComDlg.CommonDialog CDFile 
      Left            =   12000
      Top             =   360
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label Label2 
      Caption         =   "Character Enter:"
      Height          =   495
      Left            =   9000
      TabIndex        =   4
      Top             =   7440
      Width           =   1095
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuNew 
         Caption         =   "&New"
      End
      Begin VB.Menu mnuConvert 
         Caption         =   "&Convert Map"
      End
      Begin VB.Menu mnuLoad 
         Caption         =   "&Load"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Save"
      End
      Begin VB.Menu mnuQuit 
         Caption         =   "&Quit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditMap 
         Caption         =   "&Edit Map"
      End
      Begin VB.Menu mnuNPC 
         Caption         =   "&NPC Editor"
      End
   End
   Begin VB.Menu mnuAbout 
      Caption         =   "&About"
   End
End
Attribute VB_Name = "frmView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim Engine As New D3D8Engine
Dim bRunning As Boolean
Dim TileSurface As New SurfaceEdit

Const BLayer = 1
Const MLayer = 2
Const TLayer = 3
Const Walkable = 4
Const Special = 5
Const Lights = 6
Dim MouseX As Long, MouseY As Long
Dim CurrentButton As Long

Dim x1 As Integer
Dim y1 As Integer
Dim MouseSprite As New Character
Dim SCROLLSPEED As Integer
Dim bmode As Boolean
Dim actTile As Integer
Dim Layer As Integer



Private Sub cmbEdit_Click()
    Layer = cmbEdit.ListIndex + 1
    
    If Layer = Special Or Layer = Walkable Or Layer = Lights Then
        oMap.SpecialVisible = True
    Else
        oMap.SpecialVisible = False
    End If
    
End Sub

Private Sub cmddown_Click()
    oMap.ScrollDown TILEHEIGHT * 5
End Sub

Private Sub cmdFill_Click()
    Dim tmpY As Integer
    Dim tmpX As Integer
                
    For tmpY = 0 To oMap.Height - 1
        For tmpX = 0 To oMap.Width - 1
            oMap.SetTileBottom tmpX, tmpY, actTile
        Next tmpX
    Next tmpY
    
End Sub

Private Sub cmdLeft_Click()
    oMap.ScrollLeft TILEHEIGHT * 5
End Sub

Private Sub cmdRight_Click()
    oMap.ScrollRight TILEHEIGHT * 5
End Sub

Private Sub cmdUp_Click()
    oMap.ScrollUp TILEHEIGHT * 5
End Sub

Private Sub Form_Load()
    cmbEdit.AddItem "Bottom Layer", 0
    cmbEdit.AddItem "Middle Layer", 1
    cmbEdit.AddItem "Top Layer", 2
    cmbEdit.AddItem "Walkability", 3
    cmbEdit.AddItem "Data", 4
    cmbEdit.AddItem "Lights", 5
End Sub

Private Sub Form_Unload(Cancel As Integer)
    bRunning = False
End Sub

' Main game loop
Public Sub Edit()
    
    bRunning = True
    
    SCROLLSPEED = 100
    
    TileSurface.TileColorKey = oMap.TileColorKey
    TileSurface.TileSetHeight = oMap.TileSetHeight
    TileSurface.TileSetWidth = oMap.TileSetWidth
    TileSurface.DisplayHeight = Int(picSurface.Height / TILEHEIGHT)
    TileSurface.DisplayWidth = Int(picSurface.Width / TILEWIDTH)
    
    VScroll1.Min = 0
    VScroll1.Max = (TileSurface.TileSetHeight * TileSurface.TileSetWidth / TileSurface.DisplayWidth - TileSurface.DisplayHeight - 1) / 2
    
    TileSurface.CreateTileSetOffset
    
    Engine.SetupLights 0
    
    ' enter the main game loop, repeat while not marked as "Should Quit"
    Do While bRunning

        TileSurface.DrawMe
        
        Engine.StartRender
        
        Engine.DrawAll oMap, False

        Engine.PlotText "" & actTile, 32, 32, COLOR_RED
        Engine.PlotText "" & x1 & "," & y1, 64, 64, COLOR_RED

        
        
        ' show the backbuffer on the screen (swap backbuffer and primary surface)
        Engine.EndRender

        DoEvents
    Loop

End Sub

Public Sub RunMe()
    Me.Show
    
    Engine.aHwnd = Picture1.hWnd

    TileSurface.aHwnd = picSurface.hWnd
    
    Engine.InitD3D True
    
    TileSurface.InitD3D
    
    If Not Engine.LoadSurface(oMap.SurfaceName, CommonPath & "\" & oMap.SurfaceName, COLOR_BLACK) Then
        MsgBox "Error loading TileSet"
    End If
    
    If Not Engine.LoadSurface("TalkBox", CommonPath & "\talkbox.bmp") Then
        MsgBox "Error Loading Character Sprite"
    End If
    
    TileSurface.LoadSurface (CommonPath & "\" & oMap.SurfaceName)

    If Not Engine.LoadSurface("SpecialData", CommonPath & "\walkicon.bmp") Then
        MsgBox "Error Loading Data surface"
    End If
    
    Engine.SetUpFont "Arial", 16, True
    
    Layer = BLayer
    
    Edit
    
    Engine.KillSurface oMap.SurfaceName
    Engine.KillSurface "SpecialData"
    
    TileSurface.TerminateD3D
    Engine.TerminateD3D
    
End Sub

Private Sub mnuAbout_Click()
    frmAbout.Show
End Sub

Private Sub mnuEditMap_Click()
    If oMap.IsSet = True Then
        RunMe
    Else
        MsgBox "Must Load/Create map first"
    End If
End Sub

Private Sub mnuLoad_Click()
    
    bRunning = False
    
    ' CancelError is True.
    On Error GoTo ErrHandler
   
    ' Set filters.
    CDFile.Filter = "All Files (*.*)|*.*|Map Files (*.map)|*.map"
   
    ' Specify default filter.
    CDFile.FilterIndex = 2

    ' Display the Open dialog box.
    CDFile.ShowOpen
   
    If CDFile.FileName = "" Then Exit Sub
   
    oMap.sFilename = CDFile.FileName

    oMap.LoadMap
   
    txtEnterX.Text = oMap.CharStartX
    txtEnterY.Text = oMap.CharStartY
   
    Exit Sub

ErrHandler:
' User pressed Cancel button.
    Exit Sub
End Sub


Private Sub mnuNew_Click()
    Me.Hide
    frmCreate.Show
End Sub

Private Sub mnuNPC_Click()
    
    If oMap.IsSet = False Then
        MsgBox "Must load a map first"
        Exit Sub
    End If
    
    frmNPC.Show
    Me.Hide
End Sub


Private Sub mnuQuit_Click()
    Unload Me
    End
End Sub

Private Sub mnuSave_Click()
    If oMap.IsSet = True Then
        oMap.SaveMap
    Else
        MsgBox "Must Load/Create a map first"
    End If
End Sub

Private Sub PicSurface_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

    x = x \ TILEWIDTH
    y = y \ TILEHEIGHT
            
    ' Get tile from tileset
    If Button = 1 Then
        actTile = x + (TileSurface.DisplayWidth * y) + TileSurface.TileSurfaceOffsetY * TileSurface.DisplayWidth
    End If
                
End Sub


Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
            
        If bRunning Then
            MouseX = x
            MouseY = y
     
            x1 = Int((MouseX) \ TILEWIDTH + oMap.MapOffsetX \ TILEWIDTH)
            y1 = Int((MouseY) \ TILEHEIGHT + oMap.MapOffsetY \ TILEHEIGHT)
            
            If x1 < 0 Then
                x1 = oMap.Width + x1
            ElseIf x1 >= oMap.Width Then
                x1 = x1 - oMap.Width
            End If
            
            If y1 < 0 Then
                y1 = oMap.Height + y1
            ElseIf y1 >= oMap.Height Then
                y1 = y1 - oMap.Height
            End If
            
            Select Case Layer
                Case BLayer
                    If Button = 1 Then
                        oMap.SetTileBottom x1, y1, actTile
                    ElseIf Button = 2 Then
                        oMap.SetTileBottom x1, y1, 0
                    End If
                    
                Case MLayer
                    If Button = 1 Then
                        oMap.SetTileMiddle x1, y1, actTile
                    ElseIf Button = 2 Then
                        oMap.SetTileMiddle x1, y1, 0
                    End If
                
                Case TLayer
                    If Button = 1 Then
                        oMap.SetTileTop x1, y1, actTile
                    ElseIf Button = 2 Then
                        oMap.SetTileTop x1, y1, 0
                    End If
                
                Case Walkable
                    If Button = 1 Then
                        oMap.SetTileData x1, y1, 1
                    ElseIf Button = 2 Then
                        oMap.SetTileData x1, y1, 0
                    End If
                
                Case Special
                    If Button = 1 Then
                        frmEvent.EditTileData x1, y1
                    ElseIf Button = 2 Then
                        oMap.SetTileData x1, y1, 0
                    End If
                    
                Case Lights
                    If Button = 1 Then
                        oMap.AddLight x1, y1
                    ElseIf Button = 2 Then
                        oMap.DeleteLight x1, y1
                    End If
            End Select
        End If
End Sub

Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
            
        If bRunning Then
            MouseX = x
            MouseY = y
     
            x1 = Int((MouseX) \ TILEWIDTH + oMap.MapOffsetX \ TILEWIDTH)
            y1 = Int((MouseY) \ TILEHEIGHT + oMap.MapOffsetY \ TILEHEIGHT)
            
            If x1 < 0 Then
                x1 = oMap.Width + x1
            ElseIf x1 >= oMap.Width Then
                x1 = x1 - oMap.Width
            End If
            
            If y1 < 0 Then
                y1 = oMap.Height + y1
            ElseIf y1 >= oMap.Height Then
                y1 = y1 - oMap.Height
            End If
            
            Select Case Layer
                Case BLayer
                    If Button = 1 Then
                        oMap.SetTileBottom x1, y1, actTile
                    ElseIf Button = 2 Then
                        oMap.SetTileBottom x1, y1, 0
                    End If
                    
                Case MLayer
                    If Button = 1 Then
                        oMap.SetTileMiddle x1, y1, actTile
                    ElseIf Button = 2 Then
                        oMap.SetTileMiddle x1, y1, 0
                    End If
                
                Case TLayer
                    If Button = 1 Then
                        oMap.SetTileTop x1, y1, actTile
                    ElseIf Button = 2 Then
                        oMap.SetTileTop x1, y1, 0
                    End If
                
                Case Walkable
                    If Button = 1 Then
                        oMap.SetTileData x1, y1, 1
                    ElseIf Button = 2 Then
                        oMap.SetTileData x1, y1, 0
                    End If
            End Select
        End If

End Sub

Private Sub txtEnterX_Change()
    oMap.CharStartX = Val(txtEnterX.Text)
End Sub

Private Sub txtEnterY_Change()
    oMap.CharStartY = Val(txtEnterY.Text)
End Sub

Private Sub VScroll1_Change()
    TileSurface.TileSurfaceOffsetY = VScroll1.value * 2
End Sub

